--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows your Leatherworking skill level.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "LEAM"
local LEAM, prevLEAM = 0.0, -2
local LEAMmax = 0
local LEAMIncrease = 0
local startskill
-----------------------------------------------
local function OnClick(self, button)
	if (button == "LeftButton") then
		local prof = L["leatherworking"]
		CastSpellByName(prof)
	end
end
-----------------------------------------------
local function OnUpdate(self, id)
	local prof1, prof2 = GetProfessions();

	local skillLevel = 0
	local maxSkillLevel = 0

	if prof1 ~= nil then
		local name, _, skillLevel, maxSkillLevel, _, _, _, IncreaseSkillLevel = GetProfessionInfo(prof1)
		if name == L["leatherworking"] then
			LEAM = skillLevel
			LEAMmax = maxSkillLevel
			LEAMIncrease = IncreaseSkillLevel
			if not startskill then startskill = skillLevel end
		elseif prof2 ~= nil then
			local name, _, skillLevel, maxSkillLevel, _, _, _, IncreaseSkillLevel = GetProfessionInfo(prof2)
			if name == L["leatherworking"] then
				LEAM = skillLevel
				LEAMmax = maxSkillLevel
				LEAMIncrease = IncreaseSkillLevel
				if not startskill then startskill = skillLevel end
			end
		end
	end

	if LEAM == prevLEAM and LEAMmax == preLEAMmax and prevLEAMIncrease == LEAMIncrease then
		return
	end

	preLEAMmax = LEAMmax
	prevLEAM = LEAM
	prevLEAMIncrease = LEAMIncrease

	TitanPanelButton_UpdateButton(id)
	return true
end
-----------------------------------------------
local function GetButtonText(self, id)
	local LEAMtext
	local bonusText = ""
	if LEAMIncrease and LEAMIncrease > 0 then -- Bônus da profissão
		bonusText = "|r|cFFFFFFFF".." + |r|cFF69FF69"..LEAMIncrease.."|r|cFFFFFFFF "..L["bonus"].." =|r|cFF69FF69 "..(LEAM+LEAMIncrease)
	end
	local HideText = "" -- Texto HideMax
	if not TitanGetVar(ID, "HideMax") then
		HideText = "|r/|cFFFF2e2e"..LEAMmax
	end
	local SimpleText = bonusText -- Texto de bônus simples
	if TitanGetVar(ID, "SimpleBonus") and LEAMIncrease > 0 then
		SimpleText = "|r|cFFFFFFFF".." (+|r|cFF69FF69"..LEAMIncrease.."|r|cFFFFFFFF)"
	end

	local BarBalanceText = ""
	if LEAMmax ~= 0 and (LEAM - startskill) > 0 and TitanGetVar(ID, "ShowBarBalance") then
		BarBalanceText = " |cFF69FF69["..(LEAM - startskill).."]"
	end

	if LEAM == 700 then
		LEAMtext = "|cFF69FF69"..L["maximum"] .. SimpleText
	elseif LEAMmax == 0 then
		LEAMtext = "|cFFFF2e2e"..L["noprof"]
	elseif LEAM == LEAMmax then
		LEAMtext = "|cFFB4EEB4"..L["gotrainer"]
	else
		LEAMtext = "|cFFFFFFFF"..LEAM..HideText..SimpleText..BarBalanceText
	end

	return L["leatherworking"]..": ", LEAMtext
end
-----------------------------------------------
local function GetTooltipText(self, id)
	local ColorValueAccount -- Cores da conta de valor
	if not LEAM then
		ColorValueAccount = ""
	elseif LEAM == 700 then
		ColorValueAccount = ""
	elseif (LEAM - startskill) == 0 then
		ColorValueAccount = "\r"..L["session"]..TitanUtils_GetHighlightText("0")
	elseif (LEAM - startskill) > 0 then
		ColorValueAccount = "\r"..L["session"].."|cFF69FF69"..(LEAM - startskill)
	end

	local ValueText = "" -- Difere com e sem profissão
	if LEAM == 0 then
		ValueText = L["noskill"]
	else
		ValueText = L["tooltipDescription"]..L["leatherworking"].."."..ColorValueAccount
	end

	return ValueText
end
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFFccce00 "..L["leatherworking"].."|r".." Multi",
	tooltip = L["leatherworking"],
	icon = "Interface\\Icons\\Trade_leatherworking.blp",
	category = "Profession",
	version = version,
	onUpdate = OnUpdate,
	onClick = OnClick,
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareProfessionsMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		HideMax = false,
		SimpleBonus = true,
		ShowBarBalance = false,
		ShowLabelText = false,
	}
})
